unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NetView, nvplugn, ComCtrls,Menus;

type
  TForm1 = class(TForm)
    NetView1: TNetView;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    ListView1: TListView;
    Button3: TButton;
    Button4: TButton;
    ListBox1: TListBox;
    Button6: TButton;
    Button5: TButton;
    ListBox2: TListBox;
    ListBox3: TListBox;
    Button7: TButton;
    PopupMenu1: TPopupMenu;
    Recheck1: TMenuItem;
    Retrace1: TMenuItem;
    OpenNetVieweditswindow1: TMenuItem;
    Changehostscustomcomment1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure NetView1HostAlertClicked(Sender: TObject; HostId: Cardinal);
    procedure NetView1HostAlertGoOffline(Sender: TObject;
      HostId: Cardinal);
    procedure NetView1HostAlertGoOnline(Sender: TObject; HostId: Cardinal);
    procedure NetView1ListEvent(Sender: TObject; ListId, Flags: Cardinal);
    procedure NetView1NetViewActivate(Sender: TObject; Activated: Boolean);
    procedure NetView1NetViewClose(Sender: TObject);
    procedure NetView1NetWatcherConnect(Sender: TObject; HostId,
      Flags: Cardinal);
    procedure NetView1NetWatcherDisconnect(Sender: TObject;
      HostId: Cardinal);
    procedure NetView1VisualMapImageExported(Sender: TObject;
      ListId: Cardinal);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Recheck1Click(Sender: TObject);
    procedure Retrace1Click(Sender: TObject);
    procedure OpenNetVieweditswindow1Click(Sender: TObject);
    procedure Changehostsdescription1Click(Sender: TObject);
  private
    { Private declarations }
  procedure UpdateButton2;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var MajVer, MinVer, Status:integer;
    s:string;
begin
Status:=NetView1.GetNetViewStatus(MajVer, MinVer);
s:='Unknown';
case Status of
0:s:='Inaccessible';
1:s:='Read only';
2:s:='Full access';
end;
Memo1.Lines.Add('NetView v'+IntToStr(MajVer)+'.'+IntToStr(MinVer)+' Status: '+s);
end;
procedure TForm1.UpdateButton2;
begin
if NetView1.EnableEventsHandling then Button2.Caption:='Disable events'
                                 else Button2.Caption:='Enable events';
end;
procedure TForm1.Button2Click(Sender: TObject);
begin
if(Button2.Caption='Enable events')then NetView1.EnableEventsHandling:=true
                                   else NetView1.EnableEventsHandling:=false;
UpdateButton2;
end;

procedure TForm1.NetView1HostAlertClicked(Sender: TObject;
  HostId: Cardinal);
begin
Memo1.Lines.Add('OnHostAlertClicked HostId='+IntToStr(HostId));
end;

procedure TForm1.NetView1HostAlertGoOffline(Sender: TObject;
  HostId: Cardinal);
begin
Memo1.Lines.Add('OnHostAlertGoOffline HostId='+IntToStr(HostId));
end;

procedure TForm1.NetView1HostAlertGoOnline(Sender: TObject;
  HostId: Cardinal);
begin
Memo1.Lines.Add('OnHostAlertGoOnline HostId='+IntToStr(HostId));
end;

procedure TForm1.NetView1ListEvent(Sender: TObject; ListId,
  Flags: Cardinal);
begin
Memo1.Lines.Add('OnListEvent ListId='+IntToStr(ListId)+' Flags='+IntToStr(Flags));
end;

procedure TForm1.NetView1NetViewActivate(Sender: TObject;
  Activated: Boolean);
begin
Memo1.Lines.Add('OnNetViewActivate Activated='+inttostr(integer(Activated)));
end;

procedure TForm1.NetView1NetViewClose(Sender: TObject);
begin
Memo1.Lines.Add('OnNetViewClose');
UpdateButton2;
end;

procedure TForm1.NetView1NetWatcherConnect(Sender: TObject; HostId,
  Flags: Cardinal);
begin
Memo1.Lines.Add('OnNetWatcherConnect HostId='+IntToStr(HostId)+' Flags='+IntToStr(Flags));
end;

procedure TForm1.NetView1NetWatcherDisconnect(Sender: TObject;
  HostId: Cardinal);
begin
Memo1.Lines.Add('OnNetWatcherDisconnect HostId='+IntToStr(HostId));
end;

procedure TForm1.NetView1VisualMapImageExported(Sender: TObject;
  ListId: Cardinal);
begin
Memo1.Lines.Add('OnVisualMapImageExported');
end;

procedure TForm1.Button3Click(Sender: TObject);
var ti:TListItem;
    hst:nvhost;
    mv:string;
begin
ListView1.Items.Clear;
hst.id:=0;
NetView1.GetHost(hst,0);
while(hst.id<>0)do
begin
ti:=ListView1.Items.Add;
ti.Data:=pointer(hst.id);
ti.Caption:=pchar(@hst.hostname[1]);
ti.SubItems.Add(pchar(@hst.hostip[1]));
NetView1.GetMetaVar(hst.id,'map',mv);ti.SubItems.Add(mv);
NetView1.GetMetaVar(hst.id,'ctime',mv);ti.SubItems.Add(mv);
NetView1.GetMetaVar(hst.id,'ison',mv);ti.SubItems.Add(mv);
NetView1.SetMetaVar(hst.id,'test','TeSt');
NetView1.GetMetaVar(hst.id,'test',mv);ti.SubItems.Add(mv);
setlength(mv,0);NetView1.SetMetaVar(hst.id,'test',mv);
hst.id:=hst.nextid;
if(hst.id<>0)then NetView1.GetHost(hst,0);
end;

end;

procedure TForm1.Button4Click(Sender: TObject);
var lst:nvlist;
begin
listbox1.Clear;
lst.id:=0;
NetView1.GetList(lst);
while(lst.id<>0)do
begin
listbox1.AddItem(string(pchar(@lst.name[1]))+' - '+string(pchar(@lst.theme[1])),nil);
lst.id:=lst.nextid;
if(lst.id<>0)then NetView1.GetList(lst);
end;

end;

procedure TForm1.Button5Click(Sender: TObject);
var ar:nvarea;
begin
listbox2.Clear;
ar.id:=0;
NetView1.GetArea(ar);
while(ar.id<>0)do
begin
listbox2.AddItem(string(pchar(@ar.mapname[1]))+'\'+string(pchar(@ar.name[1])),nil);
ar.id:=ar.nextid;
if(ar.id<>0)then NetView1.GetArea(ar);
end;
end;

procedure TForm1.Button6Click(Sender: TObject);
var ln:nvline;
    i,cnt:integer;
begin
listbox3.Clear;
ln.index:=-1;
cnt:=NetView1.GetLine(ln);
for i:=0 to cnt-1 do
begin
ln.index:=i;
NetView1.GetLine(ln);
listbox3.AddItem(string(pchar(@ln.mapname[1]))+'\'+string(pchar(@ln.ltype[1]))+', nodes='+inttostr(ln.nodes),nil);
end;
end;



procedure TForm1.Button7Click(Sender: TObject);
begin
NetView1.Action(NVACTION_RECHECK or NVACTION_LIST,0);
end;

procedure TForm1.Recheck1Click(Sender: TObject);
begin
if listview1.selected<>nil then
begin
NetView1.Action(NVACTION_RECHECK,dword(listview1.selected.Data));
end;
end;

procedure TForm1.Retrace1Click(Sender: TObject);
begin
if listview1.selected<>nil then
begin
NetView1.Action(NVACTION_RETRACE,dword(listview1.selected.Data));
end;
end;

procedure TForm1.Changehostsdescription1Click(Sender: TObject);
var mv:string;
begin
if listview1.selected<>nil then
begin
setlength(mv,0);NetView1.GetMetaVar(dword(listview1.selected.Data),'cdesc',mv);
mv:=InputBox('Edit host''s description','Enter description:',mv);
NetView1.SetMetaVar(dword(listview1.selected.Data),'cdesc',mv);
NetView1.Action(NVACTION_SETSTATE,dword(listview1.selected.Data));
end;
end;

procedure TForm1.OpenNetVieweditswindow1Click(Sender: TObject);
begin
if listview1.selected<>nil then
begin
if NetView1.Action(NVACTION_EDIT,dword(listview1.selected.Data))=0 then MessageBox(Handle,'User pressed Cancel','Host edit',0)
                                                                   else MessageBox(Handle,'User pressed Ok','Host edit',0);
end;
end;


end.
